﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AlgorithmByCSharp.GetRedPacket
{
    class CutLineRedPacket
    {
        /// <summary>
        /// 线段切割法抢红包
        /// </summary>
        public Queue CutLineGetRedPacket(int money_YUAN, int peopleNum)
        {
            Queue moneyList_YUAN = new Queue();
            //float[] moneyList_YUAN = new float[peopleNum];
            int money_FEN = money_YUAN * 100;   // 元转为分
            int[] cutLineQueue = GetCutLineList(money_FEN, peopleNum);
            int lastCutPoint = 0;
            float curMoney_FEN = 0;
            for (int i = 0; i < peopleNum - 1; i++)
            {
                int curCutPoint = cutLineQueue[i];
                curMoney_FEN = curCutPoint - lastCutPoint;
                //moneyList_YUAN[i] = curMoney_FEN/100;
                moneyList_YUAN.Enqueue(curMoney_FEN / 100);
                lastCutPoint = curCutPoint;
            }
            curMoney_FEN = money_FEN - lastCutPoint;
            //moneyList_YUAN[peopleNum - 1] = curMoney_FEN / 100;
            moneyList_YUAN.Enqueue(curMoney_FEN / 100);
            return moneyList_YUAN;
        }

        /// <summary>
        /// 线段切割法
        /// </summary>
        /// <returns>n个人,n-1个切割点</returns>
        private int[] GetCutLineList(int money_FEN, int peopleNum)
        {
            int cutNum = peopleNum - 1;
            int[] cutLineList = new int[cutNum];
            Random random = new Random();
            int cutPoint = 0;
            int curListLen = 0;
            while (cutNum > 0)
            {
                cutPoint = random.Next(1, money_FEN - 1);
                if (CheckIsCutPointLegal(cutLineList, cutPoint))
                {
                    InsertValueWithSort(ref cutLineList, curListLen, cutPoint);
                    curListLen++;
                    cutNum--;
                }
            }
            return cutLineList;
        }
        private static bool CheckIsCutPointLegal(int[] cutLineList, int cutPoint)
        {
            bool isLegal = true;
            foreach (var item in cutLineList)
            {
                if (item == cutPoint)
                {
                    isLegal = false;
                    break;
                }
            }
            return isLegal;
        }
        private static void InsertValueWithSort(ref int[] cutList, int curListLen, int value)
        {
            bool isSwap = false;
            int temp = 0;
            int insertValue = value;
            for (int i = 0; i < curListLen; i++)
            {
                if (isSwap)
                {
                    temp = cutList[i];
                    cutList[i] = insertValue;
                    insertValue = temp;
                }
                if (value < cutList[i] && !isSwap)
                {
                    temp = cutList[i];
                    cutList[i] = insertValue;
                    insertValue = temp;
                    isSwap = true;
                }
            }
            cutList[curListLen] = insertValue;
        }
    }
}
